﻿using C1.Win.C1Document;
using C1.Win.FlexReport;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace MergeFlexReport
{
    public partial class Form1 : Form
    {
        ImageField img = null;
        public Form1()
        {
            InitializeComponent();
        }
        
        private void button1_Click(object sender, EventArgs e)
        {
            C1FlexReport flex1 = new C1FlexReport();
            flex1.Load("..\\..\\Report 1.flxr", "Report 1");
            flex1.Fields["ftrRight"].Visible = false;
            flex1.Generate();

            C1FlexReport flex2 = new C1FlexReport();
            flex2.Load("..\\..\\Report 2.flxr", "Report 2");
            flex2.Fields["ftrRight"].Visible = false;
            flex2.Generate();

            C1FlexReport mergeFlex = new C1FlexReport();
            mergeFlex.Sections.PageFooter.Height = 0;
            mergeFlex.Sections.PageHeader.Height = 0;
            mergeFlex.Sections.Header.Height = 0;
            mergeFlex.Sections.Footer.Height = 0;

            mergeFlex.Layout.MarginBottom = 0;
            mergeFlex.Layout.MarginLeft = 0;
            mergeFlex.Layout.MarginRight = 0;
            mergeFlex.Layout.MarginTop = 0;
            mergeFlex.Sections.Detail.AutoHeight = AutoSizeBehavior.GrowAndShrink;
            mergeFlex.Sections.Detail.Visible = true;

            TextField tf = (flex1.Fields["ftrRight"] as TextField);
            for (int i = 0; i < flex1.PageCount; i++)
            {
                img = new ImageField();
                SubSection section = mergeFlex.Sections.Detail.SubSections.Add();
                section.Visible = true;
                section.Height = mergeFlex.Layout.PageSize.Height;
                section.AutoHeight = AutoSizeBehavior.None;
                img.Picture = flex1.GetPageImage(i);
                img.Left = 0;
                img.Top = 0;
                img.AutoWidth = AutoSizeBehavior.CanGrow;
                img.AutoHeight = AutoSizeBehavior.GrowAndShrink;
                section.Fields.Add(img);

                TextField txt = new TextField();
                txt.Text.Expression = tf.Text.Expression;
                txt.Width = tf.Width;
                txt.Height = tf.Height;
                txt.Font = tf.Font;
                txt.Top = flex2.Layout.PageSize.Height - (flex2.Layout.MarginBottom + flex2.Sections.PageFooter.Height);
                txt.Align = tf.Align;
                txt.Left = flex2.Layout.MarginLeft + tf.Left;
                txt.AutoWidth = AutoSizeBehavior.CanGrow;
                txt.AutoHeight = AutoSizeBehavior.CanGrow;
                txt.BackColor = Color.Purple;   
                section.Fields.Add(txt);
            }
            
            for (int i = 0; i < flex2.PageCount; i++)
            {
             
                img = new ImageField();
                SubSection section = mergeFlex.Sections.Detail.SubSections.Add();
                section.Visible = true;
                section.Height = mergeFlex.Layout.PageSize.Height;
                section.AutoHeight = AutoSizeBehavior.None;
                img.Picture = flex2.GetPageImage(i);
                img.Left = 0;               
                img.Top = 0 ;
                img.AutoWidth = AutoSizeBehavior.CanGrow;
                img.AutoHeight = AutoSizeBehavior.GrowAndShrink ;
                section.Fields.Add(img);

                TextField txt = new TextField();
                txt.Text.Expression = tf.Text.Expression;
                txt.Width = tf.Width;
                txt.Height = tf.Height;
                txt.Font = tf.Font;
                txt.Top = flex2.Layout.PageSize.Height - (flex2.Layout.MarginBottom + flex2.Sections.PageFooter.Height);
                txt.Align = tf.Align;             
                txt.Left =flex2.Layout.MarginLeft+ tf.Left ;
                txt.AutoWidth = AutoSizeBehavior.CanGrow;
                txt.AutoHeight = AutoSizeBehavior.CanGrow;
                section.Fields.Add(txt);
            }

           

            mergeFlex.Render();
      
            c1FlexViewer1.DocumentSource = mergeFlex;
        }

       
    }
}
